// External variables
extern double     LotSize                   = 0.1;
extern double     StopLoss                  = 50;
extern double     TakeProfit                = 100;
extern int        Slippage                  = 5;
extern int        MagicNumber               = 1;
extern double     closeProfitPercentage     = 25;
extern int	      MA_Period                 = 10;
extern double	   Momentum_Period           = 14;
extern double	   Momentum_Buy_Restrictu    = 65;
extern double  	Momentum_Sell_Restrictu   = 30;
extern double	   Momentum_Buy_Restrictl    = 65;
extern double  	Momentum_Sell_Restrictl   = 30;
extern int        MaxTrades                 = 1;
input  bool       Use_Time_Filter           = 0;      
input  string     Time_Start                = "00:00";
input  string     Time_End                  = "23:59";

// Global variables
int BuyTicket;
int SellTicket;
double UsePoint;
int UseSlippage;
double Momentum;
double ClosingArray[100];


// Init function
int init()
  
  { 
  UsePoint=PipPoint(Symbol());
   UseSlippage=GetSlippage(Symbol(),Slippage);
  return (true); }
  
// Start function
int start()
{
int err;
OrdersClose();

//Indicator


double d_Momentum = iMomentum(Symbol(),0,Momentum_Period, PRICE_CLOSE, 1);
double sma10 = iMA(Symbol(), 0, MA_Period, 0, MODE_SMA, PRICE_CLOSE, 1);



// Buy order
   if(Open[0]>sma10 && d_Momentum>Momentum_Buy_Restrictl && d_Momentum<Momentum_Buy_Restrictu && Orders(-1) < MaxTrades && CurrBar())
     {
      // Calculate stop loss and take profit
      if(StopLoss>0) double BuyStopLoss=Ask -(StopLoss*UsePoint);
      if(TakeProfit>0) double BuyTakeProfit=Ask+(TakeProfit*UsePoint);

      if(GoodTime()){
      BuyTicket=OrderSend(Symbol(),OP_BUY,LotSize,Ask,UseSlippage,BuyStopLoss,BuyTakeProfit,"UB BUY",MagicNumber,0,clrBlue);}
      SellTicket=0;err = GetLastError();if(err!=ERR_NO_ERROR){ Print("Error on Order open = ", ErrorDescription(err));}
     }
   
 // Sell Order
   if(Open[0]<sma10 && d_Momentum>Momentum_Sell_Restrictl && d_Momentum<Momentum_Sell_Restrictu && Orders(-1) < MaxTrades && CurrBar())
     {    
      if(StopLoss>0) double SellStopLoss=Bid+(StopLoss*UsePoint);
      if(TakeProfit>0) double SellTakeProfit=Bid -(TakeProfit*UsePoint);
      if(GoodTime()){
      SellTicket= OrderSend(Symbol(),OP_SELL,LotSize,Bid,UseSlippage,SellStopLoss,SellTakeProfit,"UB SELL",MagicNumber,0,clrRed);}
      BuyTicket = 0;err = GetLastError();if(err!=ERR_NO_ERROR){ Print("Error on Order open = ", ErrorDescription(err));}
     }

   return(0);
  }
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
//+------------------------------------------------------------------+
//| Close Opened Orders                                              |
//+------------------------------------------------------------------+
bool hasProfit()
{
   int cnt;
   int total=OrdersTotal();
   double totalProfit = 0;
   for(cnt=0;cnt<total;cnt++) {
      if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      totalProfit += OrderProfit();
   }
   if (((AccountBalance() * closeProfitPercentage) / 100) < totalProfit)
      return (true);
   return (false);
}

void OrdersClose()
{ 
   int err; 
   double d_Momentum = iMomentum(Symbol(),0,Momentum_Period, PRICE_CLOSE, 1);
  // double d_Level=Open[OpenBars]-Close[CloseBars];
   for(int i = 0; i < OrdersTotal(); i++) 
      {
       bool OrSel = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);    
       if(OrderSymbol() == Symbol() && (MagicNumber == 0 || OrderMagicNumber() == MagicNumber)) 
         {
          if(OrderType() == OP_BUY && d_Momentum>Momentum_Sell_Restrictl && d_Momentum<Momentum_Sell_Restrictu && 
             iTime(NULL,0,0) > iTime(NULL,0,iBarShift(NULL,0,OrderOpenTime(),1))) 
            {
             bool closed = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 0, clrBlue);CloseOrders(0); 
             err = GetLastError(); if(err!=ERR_NO_ERROR){ Print("Error on Order closing = ", ErrorDescription(err));}
            }               
          if(OrderType() == OP_SELL && d_Momentum<Momentum_Buy_Restrictu && d_Momentum>Momentum_Buy_Restrictl &&
             iTime(NULL,0,0) > iTime(NULL,0,iBarShift(NULL,0,OrderOpenTime(),1)))   
            {
             bool closes = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 0, clrRed);CloseOrders(1); 
             err = GetLastError(); if(err!=ERR_NO_ERROR){ Print("Error on Order closing = ", ErrorDescription(err));}
             }}}  
}    
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
//+------------------------------------------------------------+
//|  Close Orders                                              |
//+------------------------------------------------------------+  
bool CloseOrders(int type)
{ //-1= All,0=Buy,1=Sell,2=BuyLimit,3=SellLimit,4=BuyStop,5=SellStop,6=All Buys,7=All Sells,8=All Market,9=All Pending;
  bool oc=0;    
  for(int i=OrdersTotal()-1;i>=0;i--){
  bool os = OrderSelect(i,SELECT_BY_POS, MODE_TRADES);
  if(OrderSymbol()==Symbol() && (MagicNumber == 0 || OrderMagicNumber() == MagicNumber))
    {   
     if(type==-1){
     if(OrderType()==0){ oc = OrderClose(OrderTicket(),OrderLots(),Bid,1000,clrGold);}
     if(OrderType()==1){ oc = OrderClose(OrderTicket(),OrderLots(),Ask,1000,clrGold);}      
     if(OrderType()>1){ oc = OrderDelete(OrderTicket());}}  
     if(OrderType()>1 && type==9){ oc = OrderDelete(OrderTicket());} 
     if(OrderType()<=1 && type==8){ oc = OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),1000,clrGold);}
     if(OrderType()==type && type==0){ oc = OrderClose(OrderTicket(),OrderLots(),Bid,1000,clrGold);}
     if(OrderType()==type && type==1){ oc = OrderClose(OrderTicket(),OrderLots(),Ask,1000,clrGold);} 
     if(OrderType()==type && OrderType()> 1){ oc = OrderDelete(OrderTicket());} 
     if(OrderType()==0 && type==6){ oc = OrderClose(OrderTicket(),OrderLots(),Bid,1000,clrGold);}  
     if((OrderType()==2 || OrderType()== 4) && type==6){ oc = OrderDelete(OrderTicket());}   
     if(OrderType()==1 && type==7){ oc = OrderClose(OrderTicket(),OrderLots(),Bid,1000,clrGold);}  
     if((OrderType()==3 || OrderType()== 5) && type==7){ oc = OrderDelete(OrderTicket());}       
     for(int x=0;x<100;x++)
     {
      if(ClosingArray[x]==0)
      {
       ClosingArray[x]=OrderTicket();
       break; } } } }
   return(oc);
}      
// Pip Point Function

double PipPoint(string Currency)
  {
   int CalcDigits= MarketInfo(Currency,MODE_DIGITS);
   if(CalcDigits == 2|| CalcDigits == 3) double CalcPoint = 0.01;
   else if(CalcDigits==4 || CalcDigits==5) CalcPoint=0.0001;
   return(CalcPoint);
  }
// Get Sllppage Function
int GetSlippage(string Currency,int SlippagePips)
  {
   int CalcDigits= MarketInfo(Currency,MODE_DIGITS);
   if(CalcDigits == 2|| CalcDigits == 4) double CalcSlippage = SlippagePips;
   else if(CalcDigits==3 || CalcDigits==5) CalcSlippage=SlippagePips*10;
   return ( CalcSlippage);
  }

//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
//+------------------------------------------------------------------+
//| Disable trade in current bar(if one is already open)             |
//+------------------------------------------------------------------+
bool CurrBar()
{ 
   bool yes = 1;
//+------------------------------------------------------------------+
   for(int i = OrdersTotal()-1; i >= 0; i--)
      {
    	if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    	{  
    	if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
      {     
       if(OrderOpenTime() >= iTime(Symbol(),0,0)) yes = 0;   
      }}}   
   return(yes);
}     
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
//+------------------------------------------------------------------+
//| Get total order                                                  |
//+------------------------------------------------------------------+
int Orders(int type)
{
   int count=0;
   //-1= All,0=Buy,1=Sell,2=BuyLimit,3=SellLimit,4=BuyStop,5=SellStop,6=AllBuy,7=AllSell,8=AllMarket,9=AllPending;   
   for(int x=OrdersTotal()-1;x>=0;x--)
      {
      if(OrderSelect(x,SELECT_BY_POS,MODE_TRADES)){ 
      if(OrderSymbol()==Symbol() && (MagicNumber == 0 || OrderMagicNumber() == MagicNumber)) 
        {
         if(type < 0){ count++;}
         if(OrderType() == type && type >= 0){ count++;}  
         if(OrderType() <= 1 && type == 8){ count++;}  
         if(OrderType() > 1 && type == 9){ count++;}  
         if((OrderType() == 0 || OrderType() == 2 || OrderType() == 4) && type == 6){ count++;}
         if((OrderType() == 1 || OrderType() == 3 || OrderType() == 5) && type == 7){ count++;}       
        }}}   
   return(count);
}
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
//+------------------------------------------------------------------+
//| Trade Time Settings                                              |
//+------------------------------------------------------------------+   
bool GoodTime()
{
  int hs1 = StrToInteger(StringSubstr(Time_Start, 0, 2)), ms1 = StrToInteger(StringSubstr(Time_Start, 3, 2));
  int he1 = StrToInteger(StringSubstr(Time_End, 0, 2)), me1 = StrToInteger(StringSubstr(Time_End, 3, 2));

  if(!Use_Time_Filter)return(true);
  
  if(Use_Time_Filter && hs1 < he1)
    {
    if(((TimeHour(TimeCurrent()) == hs1 && TimeMinute(TimeCurrent()) >= ms1) && TimeHour(TimeCurrent()) < he1) 
    || (TimeHour(TimeCurrent()) > hs1 && TimeHour(TimeCurrent()) < he1) 
    || ((TimeMinute(TimeCurrent()) <= me1 && TimeHour(TimeCurrent()) == he1) && TimeHour(TimeCurrent()) > hs1) 
    || (TimeHour(TimeCurrent()) < he1 && TimeHour(TimeCurrent()) > hs1))
    return(true);
    }
  if(Use_Time_Filter && hs1 > he1)
    {
    if((TimeHour(TimeCurrent()) == hs1 && TimeMinute(TimeCurrent()) >= ms1 && TimeHour(TimeCurrent()) < 24)
    || (TimeHour(TimeCurrent()) > hs1 && TimeHour(TimeCurrent()) < 24)
    || (TimeHour(TimeCurrent()) == he1 && TimeMinute(TimeCurrent()) <= me1 && TimeHour(TimeCurrent()) >= 0)
    || (TimeHour(TimeCurrent()) < he1 && TimeHour(TimeCurrent()) >= 0))
    return(true);
    }    
   return(false);   
} 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string ErrorDescription(int error_code)
  {
   string error_string;
//----
   switch(error_code)
     {
      //---- codes returned from trade server
      case 0:
      case 1:   error_string="no error";                                                  break;
      case 2:   error_string="common error";                                              break;
      case 3:   error_string="invalid trade parameters";                                  break;
      case 4:   error_string="trade server is busy";                                      break;
      case 5:   error_string="old version of the client terminal";                        break;
      case 6:   error_string="no connection with trade server";                           break;
      case 7:   error_string="not enough rights";                                         break;
      case 8:   error_string="too frequent requests";                                     break;
      case 9:   error_string="malfunctional trade operation (never returned error)";      break;
      case 64:  error_string="account disabled";                                          break;
      case 65:  error_string="invalid account";                                           break;
      case 128: error_string="trade timeout";                                             break;
      case 129: error_string="invalid price";                                             break;
      case 130: error_string="invalid stops";                                             break;
      case 131: error_string="invalid trade volume";                                      break;
      case 132: error_string="market is closed";                                          break;
      case 133: error_string="trade is disabled";                                         break;
      case 134: error_string="not enough money";                                          break;
      case 135: error_string="price changed";                                             break;
      case 136: error_string="off quotes";                                                break;
      case 137: error_string="broker is busy (never returned error)";                     break;
      case 138: error_string="requote";                                                   break;
      case 139: error_string="order is locked";                                           break;
      case 140: error_string="long positions only allowed";                               break;
      case 141: error_string="too many requests";                                         break;
      case 145: error_string="modification denied because order too close to market";     break;
      case 146: error_string="trade context is busy";                                     break;
      case 147: error_string="expirations are denied by broker";                          break;
      case 148: error_string="amount of open and pending orders has reached the limit";   break;
      case 149: error_string="hedging is prohibited";                                     break;
      case 150: error_string="prohibited by FIFO rules";                                  break;
      //---- mql4 errors
      case 4000: error_string="no error (never generated code)";                          break;
      case 4001: error_string="wrong function pointer";                                   break;
      case 4002: error_string="array index is out of range";                              break;
      case 4003: error_string="no memory for function call stack";                        break;
      case 4004: error_string="recursive stack overflow";                                 break;
      case 4005: error_string="not enough stack for parameter";                           break;
      case 4006: error_string="no memory for parameter string";                           break;
      case 4007: error_string="no memory for temp string";                                break;
      case 4008: error_string="not initialized string";                                   break;
      case 4009: error_string="not initialized string in array";                          break;
      case 4010: error_string="no memory for array\' string";                             break;
      case 4011: error_string="too long string";                                          break;
      case 4012: error_string="remainder from zero divide";                               break;
      case 4013: error_string="zero divide";                                              break;
      case 4014: error_string="unknown command";                                          break;
      case 4015: error_string="wrong jump (never generated error)";                       break;
      case 4016: error_string="not initialized array";                                    break;
      case 4017: error_string="dll calls are not allowed";                                break;
      case 4018: error_string="cannot load library";                                      break;
      case 4019: error_string="cannot call function";                                     break;
      case 4020: error_string="expert function calls are not allowed";                    break;
      case 4021: error_string="not enough memory for temp string returned from function"; break;
      case 4022: error_string="system is busy (never generated error)";                   break;
      case 4050: error_string="invalid function parameters count";                        break;
      case 4051: error_string="invalid function parameter value";                         break;
      case 4052: error_string="string function internal error";                           break;
      case 4053: error_string="some array error";                                         break;
      case 4054: error_string="incorrect series array using";                             break;
      case 4055: error_string="custom indicator error";                                   break;
      case 4056: error_string="arrays are incompatible";                                  break;
      case 4057: error_string="global variables processing error";                        break;
      case 4058: error_string="global variable not found";                                break;
      case 4059: error_string="function is not allowed in testing mode";                  break;
      case 4060: error_string="function is not confirmed";                                break;
      case 4061: error_string="send mail error";                                          break;
      case 4062: error_string="string parameter expected";                                break;
      case 4063: error_string="integer parameter expected";                               break;
      case 4064: error_string="double parameter expected";                                break;
      case 4065: error_string="array as parameter expected";                              break;
      case 4066: error_string="requested history data in update state";                   break;
      case 4099: error_string="end of file";                                              break;
      case 4100: error_string="some file error";                                          break;
      case 4101: error_string="wrong file name";                                          break;
      case 4102: error_string="too many opened files";                                    break;
      case 4103: error_string="cannot open file";                                         break;
      case 4104: error_string="incompatible access to a file";                            break;
      case 4105: error_string="no order selected";                                        break;
      case 4106: error_string="unknown symbol";                                           break;
      case 4107: error_string="invalid price parameter for trade function";               break;
      case 4108: error_string="invalid ticket";                                           break;
      case 4109: error_string="trade is not allowed in the expert properties";            break;
      case 4110: error_string="longs are not allowed in the expert properties";           break;
      case 4111: error_string="shorts are not allowed in the expert properties";          break;
      case 4200: error_string="object is already exist";                                  break;
      case 4201: error_string="unknown object property";                                  break;
      case 4202: error_string="object is not exist";                                      break;
      case 4203: error_string="unknown object type";                                      break;
      case 4204: error_string="no object name";                                           break;
      case 4205: error_string="object coordinates error";                                 break;
      case 4206: error_string="no specified subwindow";                                   break;
      default:   error_string="unknown error";
     }
//----
   return(error_string);
  }  
//+------------------------------------------------------------------+
